PhotoContest/PhotoContest/Controllers/ApiControllers/PhotoController.cs
using AutoMapper;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using PhotoContest.Domain.ViewModels.PhotoViewModels;
using PhotoContest.Data.Exceptions;
using PhotoContest.Domain.Contracts.Services;
using PhotoContest.Domain.DataTransferObjects;
using System;
using System.Threading.Tasks;
using PhotoContest.Domain.Paging;
using PhotoContest.Api.Helpers;
using PhotoContest.Api.ViewModels.PaginationViewModels;
using PhotoContest.Data.Validators;
using FluentValidation.Results;
using Microsoft.AspNetCore.Hosting;
using System.IO;

namespace PhotoContest.Api.Controllers
{
    [Route("api/Photos")]
    [ApiController]
    public class PhotoController: BaseController
    {
        private readonly IPhotoService _service;
        private readonly IWebHostEnvironment _webHostEnvironment;

        public PhotoController(IPhotoService service, IMapper mapper
            ,IWebHostEnvironment webHostEnvironment) : base(mapper)
        {
            _service = service;
            _webHostEnvironment = webHostEnvironment;
        }

        [HttpGet]
        public async Task<IActionResult> GetPaginated([FromQuery] PagingOptionsModel optionsModel)
        {
            if (!ValidateSortingProperty<PhotoGetViewModel>(optionsModel))
            {
                return BadRequest(string.Format("Invalid property for sorting:\nProperty {0} does not exist or can't be sorted."
                    , optionsModel.SortBy));
            }

            var options = _mapper.Map<PagingOptions>(optionsModel);

            var paginatedUsers = _mapper.Map<PaginatedListGetModel<PhotoGetViewModel>>(await _service.GetPaginated(options));

            return this.StatusCode(StatusCodes.Status200OK, paginatedUsers);
        }

        [HttpGet("{id}")]
        public async Task<IActionResult> Get(int id)
        {
            var output = await _service.GetById(id);

            var result = _mapper.Map<PhotoGetViewModel>(output);

            return Ok(result);
        }

        [HttpPost]
        public async Task<IActionResult> Post(PhotoPostViewModel model)
        {
            PhotoValidator _validator = new PhotoValidator();
            ValidationResult validResult = _validator.Validate(model);

            if (!validResult.IsValid)
            {
                if (model.PhotoFile != null)
                {
                    string photosFolder = "Photos/";
                    photosFolder += Guid.NewGuid().ToString() + "_" + model.PhotoFile.FileName;

                    model.PhotoUrl = "/" + photosFolder;

                    string serverFolder = Path.Combine(_webHostEnvironment.WebRootPath, photosFolder);

                    await model.PhotoFile.CopyToAsync(new FileStream(serverFolder, FileMode.Create));
                }

                return BadRequest(validResult.Errors);
            }

            var input = _mapper.Map<PhotoDTO>(model);
            var output = await _service.Create(input);

            var result = _mapper.Map<PhotoGetViewModel>(output);

            return Ok(result);
        }

        //[HttpPut("{id}")]
        //public async Task<IActionResult> Put(int id, PhotoPostViewModel model)
        //{
        //    PhotoValidator _validator = new PhotoValidator();
        //    ValidationResult validResult = _validator.Validate(model);
        //
        //    if (!validResult.IsValid)
        //    {
        //        return BadRequest(validResult.Errors);
        //    }
        //
        //    try
        //    {
        //        var input = _mapper.Map<PhotoDTO>(model);
        //        input.Id = id;
        //
        //        var output = await _service.Update(input);
        //        var result = _mapper.Map<PhotoGetViewModel>(output);
        //
        //        return this.StatusCode(StatusCodes.Status200OK, result);
        //    }
        //    catch (EntityNotFoundException e)
        //    {
        //        return this.StatusCode(StatusCodes.Status404NotFound, e.Message);
        //    }
        //    catch (DuplicateEntityException e)
        //    {
        //        return this.StatusCode(StatusCodes.Status409Conflict, e.Message);
        //    }
        //}

        [HttpDelete("{id}")]
        public async Task<IActionResult> Delete(int id)
        {
            var result = await _service.Delete(id);

            if (!result)
            {
                return NotFound();
            }

            return Ok();
        }
    }
}

PhotoContest/PhotoContest/Controllers/PhotosController.cs
using AutoMapper;
using FluentValidation.Results;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using PhotoContest.Api.Helpers;
using PhotoContest.Api.ViewModels.PaginationViewModels;
using PhotoContest.Data.Validators;
using PhotoContest.Domain.Contracts.Services;
using PhotoContest.Domain.DataTransferObjects;
using PhotoContest.Domain.Paging;
using PhotoContest.Domain.ViewModels.PhotoViewModels;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace PhotoContest.Api.Controllers
{
    public class PhotosController : BaseController
    {
        private readonly IContestService _contestService;
        private readonly IUserService _userService;
        private readonly IPhotoService _photoService;
        private readonly IWebHostEnvironment _webHostEnvironment;

        public PhotosController(IContestService contestService, IPhotoService photoService, IMapper mapper,
            IWebHostEnvironment webHostEnvironment, IUserService userService) : base(mapper)
        {
            _contestService = contestService;
            _photoService = photoService;
            _webHostEnvironment = webHostEnvironment;
            _userService = userService;
    }

        public IActionResult Create(int contestId)
        {
            PhotoPostViewModel photoViewModel = new()
            {
                ContestId = contestId
            };
            return View(photoViewModel);
        }
        public IActionResult Index()
        {
            return View();
        }
        public async Task<IActionResult> AllPhotos(int contestId)
        {
            var photosDtos = await _photoService.GetPhotosForContest(contestId);
            var contestDto = await _contestService.GetById(contestId);

            ViewData["contestId"] = contestId;
            TempData["contestTitle"] = contestDto.Title;
            
            return View(photosDtos);
        }


        [HttpPost]
        public async Task<IActionResult> Create(PhotoPostViewModel model, int contestId)
        {
            PhotoValidator _validator = new PhotoValidator();
            ValidationResult validResult = _validator.Validate(model);

            var user = await _userService.GetByUsername(HttpContext.Session.GetString("CurrentUser"));

            if (!validResult.IsValid)
            {
                return BadRequest(validResult.Errors);
            }

            model.UserId = user.Id;
            model.ContestId = contestId;

            string photosFolder = "Photos/";
            photosFolder += Guid.NewGuid().ToString() + "_" + model.PhotoFile.FileName;

            model.PhotoUrl = "/" + photosFolder;

            string serverFolder = Path.Combine(_webHostEnvironment.WebRootPath, photosFolder);

            await model.PhotoFile.CopyToAsync(new FileStream(serverFolder, FileMode.Create));

            await _photoService.Create(model);

            return View(model);
        }
    }
}

PhotoContest/PhotoContest/Controllers/RatingsController.cs
using AutoMapper;
using FluentValidation.Results;
using Microsoft.AspNetCore.Mvc;
using PhotoContest.Data.Validators;
using PhotoContest.Domain.Contracts.Services;
using PhotoContest.Domain.DataTransferObjects;
using PhotoContest.Domain.ViewModels.RatingViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PhotoContest.Api.Controllers
{
    public class RatingsController : BaseController
    {
        private readonly IRatingService _service;
        public RatingsController(IRatingService service, IMapper mapper) : base(mapper)
        {
            _service = service;
        }
        public IActionResult Create(int photoId)
        {
            RatingPostViewModel ratingViewModel = new()
            {
                PhotoId = photoId
            };
            return View(ratingViewModel);
        }

        [HttpPost]
        public async Task<IActionResult> Create(RatingPostViewModel model)
        {
            RatingValidator _validator = new RatingValidator();
            ValidationResult validResult = _validator.Validate(model);

            if (!validResult.IsValid)
            {
                return BadRequest(validResult.Errors);
            }

            var input = _mapper.Map<RatingDTO>(model);
            var result = await _service.Create(input);

            return RedirectToAction("Index", "Contests");
        }
    }
}

PhotoContest/PhotoContest/Views/Photos/AllPhotos.cshtml
@using PhotoContest.Domain.ViewModels.PhotoViewModels;
@using PhotoContest.Api.ViewModels.PaginationViewModels;


@model List<PhotoGetViewModel>;


@{
    Layout = "_Layout";
}


<h2>Participating photos</h2>

<div class="container">

    <div class="row">

        @foreach (var photo in Model)

        {

            <div class="col-md-4">
                <div class="card mb-4 shadow-sm">
                    <img src="@(string.IsNullOrEmpty(photo.PhotoUrl) ? "/Photos/noimage.png" : photo.PhotoUrl)" class="img-thumbnail" />
                    <div class="card-body">
                        <h3 class="card-title">@(string.IsNullOrEmpty(photo.Title) ? "Name is not available" : photo.Title)</h3>
                        <p class="card-text">@(string.IsNullOrEmpty(photo.Story) ? "No story availabe": photo.Story)</p>
                        <div class="d-flex justify-content-between align-items-center">
                            <div class="btn-group">
                                <a asp-controller="Ratings" asp-action="Create" asp-route-photoId="@photo.Id"
                                   class="btn btn-sm btn-outline-secondary"> Rate this photo!</a>
                            </div>
                            <small class="text-muted">@(string.IsNullOrEmpty(photo.Username) ? "NA" : photo.Username)</small>
                            <small class="text-muted">@(string.IsNullOrEmpty(photo.Scoring.ToString()) ? "NA" : photo.Scoring)</small>
                        </div>
                    </div>
                </div>
            </div>
        }

    </div>
</div>

PhotoContest/PhotoContest/Views/Photos/Create.cshtml
@model PhotoPostViewModel
@using PhotoContest.Domain.ViewModels.PhotoViewModels
@{
    ViewData["Title"] = "Add new photo";
}
@{
    ViewData["Title"] = "Contest Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Have a look at our contest project <a href="">where photo enthusiasts can partake</a>.</p>
</div>
<div class="container">
    <h3 class="display-4">Add new photo</h3>

    <hr />
    @if (ViewBag.IsSuccess == true)
    {
        <div class="alert alert-success alert-dismissible fade show" role="alert">
            <strong>Congratulations</strong> You have added a new photo successfully. <br />
            Click <a asp-controller="Photos" asp-action="Create" asp-route-id="@Model.ContestId">here</a> to view the details
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    }

    <form method="post" enctype="multipart/form-data" asp-action="Create" asp-controller="Photos" asp-route-contestId="@Model.ContestId ">
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>

        <div class="form-group">
            <label asp-for="Title" class="control-label"></label>
            <input asp-for="Title" class="form-control" />
            <span asp-validation-for="Title" class="text-danger"></span>
        </div>

        <div class="form-group">
            <label asp-for="Story" class="control-label"></label>
            <input asp-for="Story" class="form-control" />
            <span asp-validation-for="Story" class="text-danger"></span>
        </div>


        <div class="form-group">
            <label asp-for="PhotoFile" class="control-label"></label>
            <div class="custom-file">
                <input asp-for="PhotoFile" class="custom-file-input" id="customFile">
                <label class="custom-file-label" for="customFile">Choose file</label>
            </div>
            <span asp-validation-for="PhotoFile" class="text-danger"></span>
        </div>
        <div class="form-group">
            <input type="submit" value="Add photo" class="btn btn-primary" />
        </div>
    </form>
</div>